// (SAMPLE FROM SUMMER 2004) 

// Homework 2 part 2 problem 4.32 pages 317-318 in textbook

/*  This program uses recursive and iterative versions of palindrome
   determining algorithms.  The user is prompted to enter alphanumeric
   strings of up to 80 characters long.  The user is then asked to pick
   which algorithm to use. Both algorithms takes as input a string and
   return a boolean value of either "true" or "false".  The program
   continues prompting user for new strings until the user specifies to
   quit the program. Program features the use of an array of pointers
   to functions.  Other features include use of "bool" and "size_t" data
   types as well as std::cin.getline and std::cin.ignore fuunctions.
*/

#include <iostream>

using std::cout;
using std::cin;
using std::endl;

// Contains function prototypes for function exit
#include <cstdlib>

// Contains function prototypes for string functions
#include <cstring>

// Maximum length of user inputted string including "\0" (String terminator)
#define max_length 81

void edit_the_string(char[], char[]);

// Palindrome determining functions
bool IterPalindrome(char[], size_t, size_t);
bool RecPalindrome(char[], size_t, size_t);

int main()
{
 // initialize array of 2 pointers to functions that each take a
 // char array and int as arguments and return a boolean value
   bool (*fSort[2])(char [], size_t, size_t) = { RecPalindrome, IterPalindrome };

   char users_string[max_length];

 // String created after removing non-alphanumeric characters
 // and changing all UPPER case letters to LOWER case letters
   char modified_string[max_length];

   size_t str_len;

   char users_choice;  // Hold menu choice made by user

   int choice; // Change user_choice into an integer value

   do // Do-while loop executes until user specifies to quit
   {

      cout << "\nPlease enter a string of no more than 80 characters long"
           << "\nand I will determine whether your string is a Palindrome"
           << endl << endl;

      cin.getline(users_string, max_length);

      edit_the_string(users_string, modified_string);

      if (strlen(modified_string) == 0)
        str_len = 0; // Unsigned integer cannot be negative
      else
        str_len = strlen(modified_string) - 1;

      do // Do-while loop executes until user enters valid selection
      {

         cout << "\n[0] Exit the program"
              << "\n[1] Use iterative Palindrome determining algorithm"
              << "\n[2] Use recursive Palindrome determining algorithm"
              << "\n\nEnter Choice: ";

         cin >> users_choice;

         cin.ignore(max_length, '\n'); // Clear rest of input buffer

         choice = users_choice - '0';

         if ((choice < 0) || (choice > 2))
        // Then bad choice; have user try again.
           cout << "\n*** Invalid choice please try again ***\n";

      } while ((choice < 0) || (choice > 2));

      switch (choice)
      {
         case 0: exit(1); // Exit the program

         case 1: if ((fSort[choice % 2])(modified_string, 0, str_len))
                // Then string is a palindrome
                   cout << "(" << users_string << ") is a palindrome"
                        << endl << endl;
                 else
                   cout << "(" << users_string << ") is not a palindrome"
                        << endl << endl;
                 break;

         case 2: if ((fSort[choice % 2])(modified_string, 0, str_len))
                // Then string is a palindrome
                   cout << "(" << users_string << ") is a palindrome"
                        << endl << endl;
                 else
                   cout << "("<< users_string << ") is not a palindrome"
                        << endl << endl;
                 break;

      } // End switch

      cout << "Do you want to do another string?\n"
           << "Enter Yes or No ( Y / N ): ";

      cin >> users_choice;
      
      cin.ignore(max_length, '\n'); // Clear rest of input buffer

      if (users_choice == 'N' || users_choice == 'n')
        choice = 0;

   } while (choice != 0);

return 0;

} // End function main


//  Function removes non-alphanumeric characters from user's string and
// also changes all letters to lower case letters

void edit_the_string(char user_str[max_length], char fixed_str[max_length])
{
   int user_index = 0;
   int fixed_index = 0;

   while ((user_str[user_index] != '\0') && (user_index < max_length))
   {
      if ((ispunct(user_str[user_index])) || (isspace(user_str[user_index])))
        user_index++;

      else
        fixed_str[fixed_index++] = tolower(user_str[user_index++]);

   } // End while loop

   fixed_str[fixed_index] = '\0'; // Be sure string terminator is there

} // End function edit_the_string


// Function uses iterative version of palindrome determining algorithm
bool IterPalindrome(char fixed_str[max_length], size_t left, size_t right)
{
   if (left == right)
  // Then either it is a null string or a single character string
     return(true);

// Else string is >= length of 2 characters
   while (left < right)
   {
      if (fixed_str[left] != fixed_str[right])
        return(false);

      else // Compare next two charaters
      {
        left++;
        right--;
      }
   }

   if (left >= right)
     return(true);

   else // Should never get here
     return(false);

} // End function IterPalindrome


// Function uses recursive version of palindrome determining algorithm
bool RecPalindrome(char fixed_str[max_length], size_t left, size_t right)
{
   if (left >= right) // Base case which ends recursive calls
     return(true);

// Else string is >= 2 characters in length
   if (fixed_str[left] != fixed_str[right])
     return(false);

// Make recursive call to itself
   return RecPalindrome(fixed_str, left+1, right-1);

} // End function RecPalindrome