// (SAMPLE FROM SUMMER 2004)

// Problem 4.31 page 317 in textbook

/*  This program uses recursive and iterative versions of the selection
   sort algorithm.  The user picks from a menu of four choices of how
   ten numbers between 1 and 100 are generated and sorted.  The choices
   are:
   
     [1] Iterative Sort (10 randomly generated numbers between 1 and 100)
     [2] Recursive Sort (10 randomly generated numbers between 1 and 100)
     [3] Iterative Sort (10 user inputted numbers between 1 and 100)
     [4] Recursive Sort (10 user inputted numbers between 1 and 100)

  Other features of the program are the use of an array of pointers to
  functions and the use of RAND and SRAND random number functions.
*/

#include <iostream>

using std::cout;
using std::cin;
using std::endl;

// Contains function prototypes for functions srand, rand, and exit
#include <cstdlib>

// Contains function prototypes for time
#include <ctime>

#define ARRAY_SIZE 10

// Number gathering functions
void get_random_numbers(int[]);
void user_inputted_numbers(int []);

// Sort function prototypes
void IterSort(int[], int);
void RecSort(int[], int);

// Swap function used by sort functions
void swap_them(int *const, int *const);

// Array printing function
void print_the_array(int[]);


int main()
{
    // initialize array of 2 pointers to functions that each take an
    // int array and int as arguments and return a void
    void (*fSort[2])(int [], int) = { RecSort, IterSort };

  // Array to hold 10 numbers to be sorted
    int theNumbers[ARRAY_SIZE];

    int choice;  // Hold menu choice made by user

	do {
		do
		{
			cout << "\n[0] Exit the program"
				<< "\n[1] Iterative Sort (10 random numbers between 1 and 100)"
				<< "\n[2] Recursive Sort (10 random numbers between 1 and 100)"
	            << "\n[3] Iterative Sort (10 User numbers between 1 and 100)"
		        << "\n[4] Recursive Sort (10 User numbers between 1 and 100)"
			    << "\n\nEnter Choice: ";

			cin >> choice;

			if ((choice < 0) || (choice > 4))

				cout << "\n*** Invalid choice please try again ***\n";

		} while ((choice < 0) || (choice > 4));

		if (choice == 0)
		// then exit the program
		exit(1);

		switch (choice)
		{
			case 1:		get_random_numbers(theNumbers);
						print_the_array(theNumbers);
						(fSort[choice % 2])(theNumbers, ARRAY_SIZE);
						print_the_array(theNumbers);
						break;

			case 2:		get_random_numbers(theNumbers);
					    print_the_array(theNumbers);
						(fSort[choice % 2])(theNumbers, ARRAY_SIZE);
						print_the_array(theNumbers);
						break;

			case 3:		user_inputted_numbers(theNumbers);
						print_the_array(theNumbers);
						(fSort[choice % 2])(theNumbers, ARRAY_SIZE);
						print_the_array(theNumbers);
						break;

			case 4:		user_inputted_numbers(theNumbers);
						print_the_array(theNumbers);
						(fSort[choice % 2])(theNumbers, ARRAY_SIZE);
						print_the_array(theNumbers);
						break;

			default: cout << "\n*** Something wrong exit program ***\n";
               break;

		} // End switch

	} while (choice != 0);
return 0;
} // End function main


/* *************************************************************
 * Fill array with randomly selected numbers between 1 and 100 *
 ************************************************************* */
 void get_random_numbers(int numbers[ARRAY_SIZE])
 {

    srand(time(0)); // Seed rand function

    for (int index = 0; index < ARRAY_SIZE; index++)
       numbers[index] = 1 + rand() % 100;

 } // End function get_random_numbers


/* **********************************************
 * Fill array with numbers inputted by the user *
 ********************************************** */
 void user_inputted_numbers(int numbers[ARRAY_SIZE])
 {
   int a_number, index = 0;
   bool alldone = false; // Assume false initially

   while(!alldone)
   {
     cout << "\nEnter a number between 1 and 100: ";
     cin >> a_number;

     if((a_number >= 1) && (a_number <= 100))
     {
        numbers[index] = a_number;
        index++;
     }
     else
     {
         cout << "\n*** Number " << a_number
              << " is invalid; please try again ***\n";
   }

   if(index == ARRAY_SIZE)
  // Then we are done
     alldone = true;

 } // End while loop

} // End function user_inputted_numbers


/* ******************************************************
 * Sort referenced array using iterative selection sort *
 ****************************************************** */
 void IterSort(int numbers[ARRAY_SIZE], int unsorted_nums)
 {
   int index, min, scan;

   for (index = 0; index < unsorted_nums - 1; index++)
   {
      min = index;

      for (scan = index +1; scan < unsorted_nums; scan++)
         if (numbers[scan] < numbers[min])
           min = scan;
 
    /* Swap values */
      swap_them(&numbers[min], &numbers[index]);

   } //End for loop

 } // End function IterSort


/* ******************************************************
 * Sort referenced array using recursive selection sort *
 ****************************************************** */
 void RecSort(int numbers[ARRAY_SIZE], int unsorted_nums)
 {
   int scan, max = 0;

   if (unsorted_nums == 0) // Base case that ends recursive calls
     return;

   for (scan = 1; scan <= unsorted_nums; scan++)
   {
      if(numbers[scan] > numbers[max])
        max = scan;
   }

   /* Swap values */
   swap_them(&numbers[max], &numbers[unsorted_nums]);

   RecSort(numbers, unsorted_nums - 1); // Recursive call

 } // End function RecSort


/* **********************************
 * This function swaps two integers *
 ********************************** */
 void swap_them(int *const integer1, int *const integer2)
 {
   int temp;

   temp = *integer1;
   *integer1 = *integer2;
   *integer2 = temp;

 } // End function swapthem


/* *************************************
 * This function prints out the array. *
 ************************************* */
 void print_the_array(int print_array[ARRAY_SIZE])
 {
   int i;
   cout << endl << "(";

   for (i=0; i<ARRAY_SIZE; i++)
   {
      if (i != (ARRAY_SIZE - 1))
     /* then print a comma */
        cout << " " << print_array[i] << ",";
 
      else /* don't print a comma */
        cout << " " << print_array[i];
 
   } /* End for loop */
 
   cout << " )" << endl;

 } // End function print_the_array